/*********************************************\
*   BeApple2 : Apple ][+ emulator for BeOS    *
*                                             *
*        bus.h : Memory & IO ports (Header)   *
\*********************************************/

// BUS.CPP
#include <SupportDefs.h>

typedef void  (*TIOWriteFct)(uint8 ,uint8);
typedef uint8 (*TIOReadFct )(uint8 );
extern TIOWriteFct  IOWriteBase[16];
extern TIOReadFct  IOReadBase[16];
//------------------------------------------
extern uint8 MEM[];  // Mémoire
extern uint8 ROM[];  // Mémo. ROM
extern uint8 RAMLan[]; // Carte mémoire 16ko
extern vuint8 RefMem[]; // Mémorisation écriture

extern int IOLanPage; // Page mémoire
extern bool IOLanWrite;
extern bool IOLanRead;
extern bool IOLanWriteBis; // Kesako ?

extern uint8 Busr(uint16); // Lecture bus
extern uint8 Busw(uint16,uint8); // Ecriture bus
extern bool InitBus();
extern void InitMem();

extern void SetPROM(int Slot,char *Data);
extern void SetROM(int Slot,char *Data);
extern void SetIOHooks(int Slot,TIOWriteFct WriteFct,TIOReadFct ReadFct);

extern int mouseX,mouseY,mouseB;

extern bool JoyControl;	// false=Iteration true=Time
extern bool JoyMode;	// false=mouse true=joystick
extern bool JoyPlug;	// false=aucun joystick true=joystick dispo

extern float JoyX;
extern float JoyY;
extern uint32 JoyBoutons;

extern bool OutSpk,OutTape;

extern int mouseX,mouseY,mouseB; // Position souris
