/*********************************************\
*   BeApple2 : Apple ][+ emulator for BeOS    *
*                                             *
*        cpu.h : 6502 processor (Header)      *
\*********************************************/

#include <SupportDefs.h>
#include <OS.h> 	//<KernelKit.h>

extern thread_id ThreadCPU;

const int INTER_RESET=1;
const int INTER_IRQ  =2;
const int INTER_NMI  =4;

extern vuint8  GrA,GrX,GrY;	// Registers
extern vuint8  GrSP;
extern vuint16 GrPC;
extern vuint8  GrP;

extern volatile bool StopReq;	// Start/stop CPU
extern volatile bool StopAck;	// Handshake
extern volatile bool StopCPU;	// Final END

extern bool Pause; // Pause CPU
extern int64 SimCycles;	// Cycles simulation
extern int64 TimCycles; // Cycles temporisation
extern int   FasCycles; // Cycles intermédiaires
extern vint64 StartTime;
extern volatile bool LockCPU;

extern void InitCPU();
extern void InterCPU(int Type);
extern int SwitchCPU(bool State);
extern volatile bool StopCPU;
extern int32 CPUTask(void *);
